<?php 

//ini_set('display_errors', 'On');
//error_reporting(E_ALL | E_STRICT);

$output = '<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="x-ua-compatible" content="IE=Edge"/> 
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title>Brick Painter</title>
	<meta name="author" content="Peter Craddock" />
	<link rel="stylesheet" href="brick.css" type="text/css" media="screen" />
	<!--[if lt IE 9]>
		<script src="html5shiv.js"></script>
	<![endif]-->
	<!--[if IE 7]>
		<link rel="stylesheet" href="ie7.css" type="text/css" media="screen, projection">
	<![endif]-->
	<!--[if lte IE 6]>
	<link rel="stylesheet" href="http://universal-ie6-css.googlecode.com/files/ie6.1.1.css" media="screen, projection">
	<![endif]-->
</head>
<body>
	<div id="container">
		<header id="top">
			<h1 id="logo"><a href="index.php"><span>Brick Painter</span></a></h1>
		</header>';

function errorMessage($string) {
	global $output;
	$errormsg = $output . '
		<section class="text"><p class="error">' . $string . '</p><p class="back"><a href="index.php">Back to Brick Painter form</a></p></section></div></body></html>';
	return $errormsg;
}

// Start with an image and convert it to a palette-based image

// For URL-based images:
if(!empty($_POST['source'])) {
	$source = $_POST['source'];
} else {
	$errormsg = 'No source file selected.';
	$printerror = errorMessage($errormsg);
	echo $printerror;
	return;
}

$source_headers = @get_headers($source);

if(strpos($source_headers[0],"200")) {
} else {
	$errormsg = 'Invalid source file selected.';
	$printerror = errorMessage($errormsg);
	echo $printerror;
	return;
}
$imageextension = pathinfo(parse_url($source,PHP_URL_PATH),PATHINFO_EXTENSION);
$lwextension = strtolower($imageextension);

if($lwextension == 'bmp') {
	$errormsg = 'BMP images not supported. Please try another image format.';
	$printerror = errorMessage($errormsg);
	echo $printerror;
	return;
}
// For uploaded images:
/*$imagename = $_POST['name'];
$imageextension = $_POST['ext'];
$lwextension = strtolower($imageextension);
*/

$heightselected = 0;

if(!empty($_POST['size'])) {
	if(!empty($_POST['xy'])) {
		if($_POST['xy'] == 'wide') {
			$wblocks = $_POST['size'];
		} else {
			$hblocks = $_POST['size'];
			$heightselected = 1;
		}
	} else {
		$errormsg = 'No choice of width or height selected.';
		$printerror = errorMessage($errormsg);
		echo $printerror;
		return;
	}
} else {
	$errormsg = 'No choice of dimensions selected.';
	$printerror = errorMessage($errormsg);
	echo $printerror;
	return;
}

// For uploaded images:
/*
if(!file_exists($imagename . '.' . $imageextension)) {
	die('Invalid file selected. Please respect the following URL: ?name=NAME_OF_FILE&ext=EXTENSION_OF_FILE&cmwide=WIDTH_IN_CENTIMETRES');
}

if(($lwextension == 'jpeg') || ($lwextension == 'jpg')) {
	$imagebase = imagecreatefromjpeg($imagename . '.' . $lwextension);
} elseif($lwextension == 'png') {
	$imagebase = imagecreatefrompng($imagename . '.' . $lwextension);
} elseif($lwextension == 'gif') {
	$imagebase = imagecreatefromgif($imagename . '.' . $lwextension);
}
*/

// For URL-based images:

$i = getimagesize($source);
if(!is_array($i) || empty($i)) {
	$errormsg = 'Invalid source file selected.';
	$printerror = errorMessage($errormsg);
	echo $printerror;
	return;
}


$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $source); 
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
$data = curl_exec($ch);
curl_close($ch);
$imagebase = imagecreatefromstring($data);

imagetruecolortopalette($imagebase, false, 255);

$numpixels = imagesy($imagebase) * imagesx($imagebase);
//$blocksize = imagesx($imagebase) * 8 / $sizeinmm;

$imagex = imagesx($imagebase);
$imagey = imagesy($imagebase);

if($imagex > 700) {
	$imagey = 700 * $imagey / $imagex;
	$imagex = 700;
}

if($imagey > 900) {
	$imagex = 900 * $imagex / $imagey;
	$imagey = 900;
}

if(!empty($hblocks)) {
	$blocksize = $imagey / $hblocks;
	$wblocks = floor($imagex / $blocksize);
} else {
	$blocksize = $imagex / $wblocks;
	$hblocks = floor($imagey / $blocksize);
}

// Unless "hblocks" is set, we're going to set the minimum height at 32 blocks, which is the size of a standard "large plate"
if($imagey / ($imagex / $wblocks) < 32) {
	if($heightselected == 1) {
		$blocksize = $imagey / $hblocks;
	}
}

$resizeproportion = floor($blocksize) / $blocksize;

$blocksize = floor($blocksize);

$sizex = imagesx($imagebase);
$sizey = imagesy($imagebase);
$blocks_wide = floor($imagex * $resizeproportion / $blocksize);
$blocks_high = floor($imagey * $resizeproportion / $blocksize);
$resizex = $blocks_wide*$blocksize;
$resizey = $blocks_high*$blocksize;

$im = imagecreatetruecolor($resizex, $resizey);
imagecopyresampled($im, $imagebase, 0, 0, 0, 0, $resizex, $resizey, $sizex, $sizey);

imagetruecolortopalette($im, false, 255);

$makethumbnail = 0;
// Thumbnail functionality:
if(!empty($_POST['thumb'])) {
	$makethumbnail = 1;
}

// If uploaded image:
//$imgname = 'result/' . $imagename . $colext . '-thumb.png';
$thumb = imagecreatetruecolor($blocks_wide, $blocks_high);
imagecopyresampled($thumb, $im, 0, 0, 0, 0, $blocks_wide, $blocks_high, $resizex, $resizey);
imagetruecolortopalette($thumb, false, 255);
imagefilter($thumb, IMG_FILTER_PIXELATE, 1, true);

// Colour arrays:

// Search colors (RGB)
$colorsbw = array(
	array(242, 243, 242),
	array(27, 42, 52),
);

$colorsgrey = array(
	array(242, 243, 242),
	array(27, 42, 52),
	array(163, 162, 164),
	array(99, 95, 97)
);

$colorsstd = array(
	array(242, 243, 242),
	array(215, 197, 153),
//	array(204, 142, 104),
	array(196, 40, 27),
	array(13, 105, 171),
	array(245, 205, 47),
	array(27, 42, 52),
	array(40, 127, 70),
//	array(75, 151, 74),
//	array(160, 95, 52),
	array(110, 153, 201),
	array(218, 133, 64),
	array(164, 189, 70),
//	array(146, 57, 120),
//	array(116, 134, 156),
	array(149, 138, 115),
	array(32, 58, 86),
	array(39, 70, 44),
//	array(120, 144, 129),
	array(123, 46, 47),
//	array(232, 171, 45),
	array(105, 64, 39),
	array(163, 162, 164),
	array(99, 95, 97),
//	array(229, 228, 222),
	array(159, 195, 233),
	array(205, 98, 152),
	array(228, 173, 200),
//	array(253, 234, 140),
	array(52, 43, 117)
);

$colorsbwname = array(
	'White',
	'Black'
);

$colorsgreyname = array(
	'White',
	'Black',
	'Medium stone grey',
	'Dark stone grey'
);

$colorsstdname = array(
	'White',
	'Brick yellow',
//	'Nougat',
	'Bright red',
	'Bright blue',
	'Bright yellow',
	'Black',
	'Dark green',
//	'Bright green',
//	'Dark orange',
	'Medium blue',
	'Bright orange',
	'Bright yellowish green',
//	'Bright reddish violet',
//	'Sand blue',
	'Sand yellow',
	'Earth blue',
	'Earth green',
//	'Sand green',
	'Dark red',
//	'Flame yellowish orange',
	'Reddish brown',
	'Medium stone grey',
	'Dark stone grey',
//	'Light stone grey',
	'Light royal blue',
	'Bright purple',
	'Light purple',
//	'Cool yellow',
	'Medium lavandel'
);

$colors = $colorsstd;
$colorsname = $colorsstdname;
$colext = '';
if(!empty($_POST['colours'])) {
	if($_POST['colours'] == 'grey') {
		$colors = $colorsgrey;
		$colorsname = $colorsgreyname;
	} elseif($_POST['colours'] == 'black') {
		$colors = $colorsbw;
		$colorsname = $colorsbwname;
	} else {
		$colors = $colorsstd;
		$colorsname = $colorsstdname;
	}
}

$i = 0;
//$tidx = imagecolortransparent($thumb);
$palletsize = imagecolorstotal($thumb);
while($i < $palletsize) {
	$colour = imagecolorsforindex($thumb, $i);
	$closest = 0;
	$lowestdiff = 765;
	foreach($colors as $id => $rgb) {
		$reddiff = $colour['red'] - $rgb[0];
		$greendiff = $colour['green'] - $rgb[1];
		$bluediff = $colour['blue'] - $rgb[2];
		$diff = abs($reddiff) + abs($greendiff) + abs($bluediff);
		if($diff < $lowestdiff) {
			$lowestdiff = $diff;
			$closest = $id;
		}
	}
	
	// If thumbnail to be generated, generate it - otherwise, use the standard $im:
	imagecolorset($thumb,$i,$colors[$closest][0],$colors[$closest][1],$colors[$closest][2]);
	
	$i++;
}

function getPixelCountByColor($image, $colour){ 
	$currentCount = 0; 
	for($x = 0; $x < imagesx($image); $x++){ 
		for($y = 0; $y < imagesy($image); $y++){
			$rgb = imagecolorat($image, $x, $y);
			$basecolour = imagecolorsforindex($image, $rgb); 
			if((($basecolour['red'] == $colour[0]) && ($basecolour['blue'] == $colour[2])) && ($basecolour['green'] == $colour[1])) {
				$currentCount++; 
			} 
		} 
	}
	return $currentCount;
}

function rgb2hex($rgb) {
	return '#' . sprintf('%02x', $rgb[0]) . sprintf('%02x', $rgb[1]) . sprintf('%02x', $rgb[2]);
}
$listofcolours = '';
foreach($colors as $id => $rgb_i) {
	$countcol = getPixelCountByColor($thumb,$rgb_i);
	if($countcol > 0) {
		$listofcolours .= '<tr><td>' . $colorsname[$id] . ':</td><td>' . $countcol . '</td><td><span class="colour" style="background-color:' . rgb2hex($rgb_i) . '">&nbsp;</span></td></tr>';
	} else {
	}
}


// If we're saving to disk:
/*if($crop == 'y') {
	$imgname = 'result/' . $imagename . $colext . '-thumb.png';
	imagepng($thumb, $imgname ); // save image as png
} else {
	$imgname = 'result/' . $imagename . $colext . '.png';
	imagepng($im, $imgname ); // save image as png
}*/

// If we're simply displaying the image:

// Begin capturing the byte stream
ob_start();

// generate the byte stream - the image in this case
if($makethumbnail == 1) {
	imagepng($thumb);
} else {
	imagedestroy($im);
	$im = imagecreatetruecolor($resizex, $resizey);
	imagecopyresampled($im, $thumb, 0, 0, 0, 0, $resizex, $resizey, $blocks_wide, $blocks_high);
	imagetruecolortopalette($im, false, 255);
	imagepng($im);
}
$imagevariable = ob_get_contents();

// and finally retrieve the byte stream
$rawImageBytes = ob_get_clean();

echo $output;

echo '
		<section class="text">
			<header><h2><span>Your Brick Painting</span></h2></header>
			<p>Here is your Brick Painting:</p>
		';

echo "<p><img src='data:image/jpeg;base64," . base64_encode( $rawImageBytes ) . "' /></p>";

echo '<p class="centre large"><a href="index.php">Return to <em>Brick Painter</em> form</a></p>';


imagedestroy($im);
imagedestroy($thumb);

if($makethumbnail == 1) {
	imagedestroy($thumb);
	$blocksizetext = '';
} else {
	$blocksizetext = ' (blocks are squares of ' . $blocksize . ' pixels wide in the image)';
}

echo '<p>Your Brick Painting measures ' . $blocks_wide . ' blocks across and ' . $blocks_high . ' blocks high' . $blocksizetext . '.<br />&nbsp;<br />The following colours are needed:</p><table id="resultlist"><tr><th class="one">Name of colour:</th><th class="two">Number of bricks:</th><th class="three">Colour in picture:</th></tr>' . $listofcolours . '</table>';

echo '
		</section>
		<div id="footer"><p class="copyright"><a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-nc-sa/3.0/80x15.png" /></a><br />Brick Painter (created by Peter Craddock) is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/3.0/">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. <a href="http://www.arpia.be/" title="Download page for Brick Painter">Download available through arpia.be</a>.</p>
		</div>
	</div>
</body>
</html>';


?>